webentwicklung-frage-antwort-db.com.de

Ausführen von Selenium-Chromedriver mit Protractor unter Linux

Ich verwende Winkelmesser, um Tests für eine Angular -Anwendung auszuführen. Sie funktionieren in meiner OSX-Umgebung, aber nicht unter Linux, wo TeamCity versucht, sie auszuführen.

Wenn ich diesen Befehl in meiner lokalen OSX-Umgebung ausführe, funktioniert er (auch auf meinem Kollegen-Computer getestet):

./node_modules/protractor/bin/protractor protractor.conf.js

Using ChromeDriver directly...
..
Finished in 5.55 seconds
2 tests, 2 assertions, 0 failures

Wenn ich dies auf einem Linux-Computer ausführe oder ein TeamCity-Job versucht, es auszuführen, schlägt dies fehl:

./node_modules/protractor/bin/protractor protractor.conf.js

Using ChromeDriver directly...

/usr/share/TeamCity/buildAgent/work/57bd89f9c9abb5d5/webapp/node_modules/protractor/node_modules/Selenium-webdriver/http/util.js:87
          Error('Timed out waiting for the WebDriver server at ' + url));
          ^
Error: Timed out waiting for the WebDriver server at http://127.0.0.1:52959/
    at Error (<anonymous>)
    at onResponse (/usr/share/TeamCity/buildAgent/work/57bd89f9c9abb5d5/webapp/node_modules/protractor/node_modules/Selenium-webdriver/http/util.js:87:11)
    at /usr/share/TeamCity/buildAgent/work/57bd89f9c9abb5d5/webapp/node_modules/protractor/node_modules/Selenium-webdriver/http/util.js:42:21
    at /usr/share/TeamCity/buildAgent/work/57bd89f9c9abb5d5/webapp/node_modules/protractor/node_modules/Selenium-webdriver/lib/webdriver/http/http.js:96:5
    at ClientRequest.<anonymous> (/usr/share/TeamCity/buildAgent/work/57bd89f9c9abb5d5/webapp/node_modules/protractor/node_modules/Selenium-webdriver/http/index.js:136:7)
    at ClientRequest.EventEmitter.emit (events.js:95:17)
    at Socket.socketErrorListener (http.js:1547:9)
    at Socket.EventEmitter.emit (events.js:95:17)
    at net.js:440:14
    at process._tickCallback (node.js:415:13)
==== async task ====
WebDriver.createSession()
    at Function.webdriver.WebDriver.acquireSession_ (/usr/share/TeamCity/buildAgent/work/57bd89f9c9abb5d5/webapp/node_modules/protractor/node_modules/Selenium-webdriver/lib/webdriver/webdriver.js:131:49)
    at Function.webdriver.WebDriver.createSession (/usr/share/TeamCity/buildAgent/work/57bd89f9c9abb5d5/webapp/node_modules/protractor/node_modules/Selenium-webdriver/lib/webdriver/webdriver.js:111:30)

Versuche zu lösen:

Ich habe mir dieses Problem angesehen, aber ein eigenständiger Web-Treiber-Server ist keine Lösung.

Ich habe mir dieses Problem angesehen, aber meine Version von Selenium-wedriver ist 2.42.1, also nicht derselbe Fehler.

Versionen:

$ node --version
v0.10.26

$ ./node_modules/protractor/bin/protractor --version
Version 1.0.0

$ uname -mrs
Linux 3.11.0-15-generic x86_64

Fortschrittsbericht:

Beim Versuch, die Version von chrome-webdriver zu ermitteln, ist ein Problem aufgetreten:

$ ./node_modules/protractor/Selenium/chromedriver --version
./node_modules/protractor/Selenium/chromedriver: error while loading shared libraries: libnss3.so: cannot open shared object file: No such file or directory

Daraus schloss ich, dass es ein Abhängigkeitsproblem gab und fand, dass Selenium Chrome benötigt . (Mehr) .

Ich habe Chrome auf der Linux-Box mit Schritten wie diesem installiert:

Sudo apt-get install libxss1 libappindicator1 libindicator7
Sudo wget https://dl.google.com/linux/direct/google-chrome-stable_current_AMD64.deb
Sudo dpkg -i google-chrome*.deb

Das hat nicht genau so funktioniert, aber nach ein paar Hin- und Herbewegungen mit Abhängigkeiten und Sudo apt-get install habe ich Chrome installiert:

$ google-chrome --version
Google Chrome 36.0.1985.143 

Damit hat die Chromedriver-Version funktioniert:

$ ./node_modules/protractor/Selenium/chromedriver --version
ChromeDriver 2.10.267518

Das Ausführen von Protractor funktioniert jedoch immer noch nicht:

$ ./node_modules/protractor/bin/protractor protractor.conf.js
Using ChromeDriver directly...

/usr/share/TeamCity/buildAgent/work/57bd89f9c9abb5d5/webapp/node_modules/protractor/node_modules/Selenium-webdriver/lib/atoms/error.js:109
  var template = new Error(this.message);
                 ^
UnknownError: unknown error: Chrome failed to start: exited abnormally
  (Driver info: chromedriver=2.10.267518,platform=Linux 3.11.0-15-generic x86_64)
    at new bot.Error (/usr/share/TeamCity/buildAgent/work/57bd89f9c9abb5d5/webapp/node_modules/protractor/node_modules/Selenium-webdriver/lib/atoms/error.js:109:18)
    at Object.bot.response.checkResponse (/usr/share/TeamCity/buildAgent/work/57bd89f9c9abb5d5/webapp/node_modules/protractor/node_modules/Selenium-webdriver/lib/atoms/response.js:106:9)
14
SimplGy

Sie müssen in der Lage sein, Chrome oder Firefox kopflos auszuführen, und dafür müssen Sie unter anderem Xvfb konfigurieren, da Chrome sonst ohne ein ordnungsgemäßes $ DISPLAY nicht gestartet werden kann.

Sie könnten auch PhantomJS verwenden, aber was nützt das für e2e-Tests, da dies kein echter Browser ist.

Dies ist, was ich erfolgreich für kontinuierliche Tests verwende: https://github.com/elgalu/docker-Selenium

8
Leo Gallucci

Ich hatte das gleiche Problem und es löste sich gleich nach der Installation des unity-gtk3-Moduls !!

yum install unity-gtk3-module

Installing:
 PackageKit-gtk3-module                                      
 Updating:                                                          
Installing for dependencies:
 PackageKit-glib                                                 
 adwaita-cursor-theme                                          
 adwaita-icon-theme                                             
 at-spi2-atk                                                   
 at-spi2-core                                                   
 cairo-gobject                                                  
 colord-libs                                                    
 gtk3                                                            
 json-glib                                                       
 libXevie                                                       
 libgusb                                                  
 rest                                                           
 Updating for dependencies:
 glib2

ich hoffe das hilft

1
Inforedaster